import TypeImport from "./TypeImport";
type ImportSet = {
    defaultImport?: string;
    importDefaultAsType?: boolean;
    namedImports: Set<string>;
    namedAsTypeImports: Set<string>;
};
declare class ImportGenerator {
    srcFolder: string;
    srcModuleName: string;
    /**
     * @param srcPath The path (including filename) of the module we're generating imports for.
     */
    constructor(srcPath: string);
    importMap: {
        [index: string]: ImportSet;
    };
    addImport({ name, isDefault, path: absolutePath, isAbsolute, importAsType, }: TypeImport): void;
    generateLines(): string[];
}
export default ImportGenerator;
