"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isMatch = void 0;
const isString = (str) => typeof str === "string";
const isRegExp = (str) => str instanceof RegExp;
const isPredicate = (str) => typeof str === "function";
const isMatch = (str, matcher) => {
    if (isString(matcher)) {
        return str === matcher;
    }
    if (isRegExp(matcher)) {
        return matcher.test(str);
    }
    if (isPredicate(matcher)) {
        return matcher(str);
    }
    return false;
};
exports.isMatch = isMatch;
