"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Used for identifiers. If the name is illegal Typescript, put it in quotes. */
const escapeName = (name) => {
    let isLegalIdentifier = true;
    if (name.length === 0 || name.trim() !== name) {
        isLegalIdentifier = false;
    }
    try {
        new Function("var " + name);
    }
    catch {
        isLegalIdentifier = false;
    }
    return isLegalIdentifier ? name : `'${name}'`;
};
exports.default = escapeName;
