"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.afterAll = exports.beforeAll = exports.afterEach = exports.beforeEach = exports.describe = exports.test = exports.it = exports.expect = void 0;
const vitest_1 = require("vitest");
// This reason for this weird wrapper around the vitest functions is to enable
// "test hooks": https://kristiandupont.medium.com/test-hooks-be89b760d2db.
// I am hoping they will look into it (https://github.com/vitest-dev/vitest/discussions/1364),
// but for now, this is a workaround.
var vitest_2 = require("vitest");
Object.defineProperty(exports, "expect", { enumerable: true, get: function () { return vitest_2.expect; } });
Object.defineProperty(exports, "it", { enumerable: true, get: function () { return vitest_2.it; } });
Object.defineProperty(exports, "test", { enumerable: true, get: function () { return vitest_2.test; } });
let globalScope = "";
const makeDescribeForScope = (scope) => (name, fn) => {
    (0, vitest_1.describe)(name, () => {
        const previousD = exports.describe;
        globalScope = `${scope}/${name}`;
        exports.describe = makeDescribeForScope(globalScope);
        fn();
        exports.describe = previousD;
    });
};
exports.describe = makeDescribeForScope("");
const makeHook = (map, viFunc, type) => (fn, timeout) => {
    if (!map[globalScope]) {
        map[globalScope] = [];
        // Call the function with the scope that is *currently* set,
        // not what it will be when we reach it.
        const closureScope = globalScope;
        viFunc(async () => {
            for (const fn of map[closureScope]) {
                await fn();
            }
        }, timeout);
    }
    if (type === "after") {
        map[globalScope].unshift(fn);
    }
    else {
        map[globalScope].push(fn);
    }
};
const beforeEachMap = {};
exports.beforeEach = makeHook(beforeEachMap, vitest_1.beforeEach, "before");
const afterEachMap = {};
exports.afterEach = makeHook(afterEachMap, vitest_1.afterEach, "after");
const beforeAllMap = {};
exports.beforeAll = makeHook(beforeAllMap, vitest_1.beforeAll, "before");
const afterAllMap = {};
exports.afterAll = makeHook(afterAllMap, vitest_1.afterAll, "after");
